{
  2022/04/26
  nanoCAD 5 Free

  Delphi 10.4
  f.izawa
  e-mail: f.izawa@dream.com
  URL : http://www.izawa-web.com/
}

unit ncad5Ctrl;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Classes;

var
  ncadHWndAry : array of HWND;

// EBhẼ^CgiLvVj𓾂
function GetWindowCaption(h: HWND): string;
// ̃vZX̃Rg[̕𓾂
function GetWindowStr(h: HWND): String;
// R}hCi[U[͂镔jɕ𑗐M
function ncadCommand(const cmd: string): boolean;
// N 'nanoCAD 5' ̐
function ncadCount: integer;
// DockPane ̃EBhEnh
function ncadDockPaneWindow: HWND;
// j[ o[ ̃EBhEnh
function ncadMenuBarWindow: HWND;
// wR{{bNX̃EBhEnh
function ncadGeneLayWindow: HWND;
// nanoCAD CEBhE
function ncadMainWindow: HWND;
// R}hCi[U[͂镔j̃EBhEnh
function ncadCmdEditWindow: HWND;
// R}hCi[U[͂镔j̕擾
function ncadCmdEdit: string;
// R}hC擪 Statc ̃EBhE
function ncadCmdStaticWindow: HWND;
// R}h̕擾
function ncadCmdHistWindow: HWND;
// R}h̕擾
function ncadCmdHist: String;
// }ʐƃ^CgAEBhEnh𓾂
function ncadDocsTitle(var sl: TStringList): integer;
// hLg𓾂
function ncadDocsCount: integer;
// ANeBuhLg̃^Cg
//
// gqȂ= VK}ʁiۑj
// * t= ύXiۑj
// tl[= obNAbvt@C
function ncadActiveDocTitle: string;
// OtBbNEBhẼnh
function ncadGraphicWindow: HWND;
// nanoCAD ANeBuɂăL[
procedure ncadKeybdEvent(key: UInt);
// ANeBu
function ncadActivate: HWND;
// Enter
procedure ncadSendEnter;
// ESC
procedure ncadSendCancel;
// nanoCAD ŏĂ邩
function ncadIsMinimized: boolean;
// Window ŏĂ邩
function windowIsMinimized(h: HWND): boolean;
// nanoCAD ő剻
procedure ncadShowMaxmize;
// window ő剻
procedure windowShowMaxmize(h: HWND);
// nanoCAD ݂̈ʒuƃTCYŕ\
procedure ncadShowNormal;
// window ݂̈ʒuƃTCYŕ\
procedure windowShowNormal(h: HWND);
// N EXE tpXŎ擾
function exeFullName(exeHWnd: HWND): string;
// X^[gAbvEBhE
function ncadStartupWindow: HWND;


implementation

var

  dockPaneHWnd: HWND;
  menuBarHWnd : HWND;
  geneLayHWnd : HWND;
  //ncadHWndAry : array of HWND;

function QueryFullProcessImageNameW(Process: THandle; Flags: DWORD; Buffer: PChar;
    Size: PDWORD): DWORD; stdcall; external 'kernel32.dll';

// EBhẼ^CgiLvVj𓾂
function GetWindowCaption(h: HWND): string;
var
  Title : array [0..255] of Char;
begin
  result := '';
  FillChar(Title, Sizeof(Title), #0);
  if GetWindowText(h, @Title, 255) > 0 then
    result := Title;
end;

// ̃vZX̃Rg[̕𓾂
function GetWindowStr(h: HWND): String;
var
  len: integer;
  buf: PChar;
begin
  result := '';
  len := SendMessage(h, WM_GETTEXTLENGTH, 0, 0);
  if len > 0 then begin
    buf := StrAlloc(len + 1);
    try
      SendMessage(h, WM_GETTEXT, StrBufSize(buf), LPARAM(buf));
      result := buf;
    finally
      StrDispose(buf);
    end;
  end;
end;

// R}hCi[U[͂镔jɕ𑗐M
function ncadCommand(const cmd: string): boolean;
var
  h, hCmdHist, hCmdEdit, hMain: hwnd;
  i: integer;
begin
  result := false;
  hMain := FindWindow(nil, 'nanoCAD 5');
  if IsWindow(hMain) then begin
    SetForegroundWindow(hMain);
    h := FindWindowEx(hMain, 0, nil, 'Command Line');
    h := GetWindow(h, GW_CHILD);
    h := GetWindow(h, GW_CHILD);
    hCmdHist := GetWindow(h, GW_HWNDNEXT); // Hist
    hCmdEdit := GetWindow(hCmdHist, GW_HWNDNEXT); // Edit
    // R}hEBhEôŁȂ΍
    // ɂĂ͕sv
    SetForegroundWindow(hCmdEdit); // 
    for i := 1 to Length(cmd) do begin
      SendMessage(hCmdEdit, WM_CHAR, Word(cmd[i]), 0);
      if (cmd[i] = #13) or (cmd[i] = #27) then
        sleep(200);  // 
    end;
    SetForegroundWindow(hCmdEdit); // 
    result := True;
  end;
end;

function EnumWindowProcNcadMain(h: HWND; lp: LPARAM):Bool; stdcall;
var
  ClassName : array [0..255] of Char;
  Title : array [0..255] of Char;
begin
  Result := True;
  FillChar(ClassName, SizeOf(ClassName), #0);
  FillChar(Title, SizeOf(Title), #0);
  if GetWindowText(h, @Title, 255) > 0 then begin
    if StrLComp(Title, 'nanoCAD 5', 9) = 0 then begin
      if GetClassName(h, @ClassName, 255) > 0 then begin
        if StrLComp(ClassName, 'Afx:', 4) = 0 then begin
          SetLength(ncadHWndAry, Length(ncadHWndAry) + 1);
          ncadHWndAry[Length(ncadHWndAry) - 1] := h;
          // Ō܂Ō
          //Result := False;
        end;
      end;
    end;
  end;
end;

// N 'nanoCAD 5' ̐
function ncadCount: integer;
begin
  setLength(ncadHWndAry, 0);
  EnumWindows(@EnumWindowProcNcadMain, 0);
  result := Length(ncadHWndAry);
end;

function EnumChildWindowProcDockPane(h: HWND; lp: LPARAM):Bool; stdcall;
var
  ClassName : array [0..255] of Char;
begin
  Result := True;
  FillChar(ClassName, SizeOf(ClassName), #0);
  if GetClassName(h, @ClassName, 255) > 0 then begin
    if StrLComp(ClassName, 'Afx:DockPane:', 13) = 0 then begin
      dockPaneHWnd := h;
      Result := False;
    end;
  end;
end;

function EnumChildWindowProcMenuBar(h: HWND; lp: LPARAM):Bool; stdcall;
var
  ClassName : array [0..255] of Char;
  Title : array [0..255] of Char;
begin
  Result := True;

  menuBarHWnd := 0;

  FillChar(ClassName, SizeOf(ClassName), #0);
  FillChar(Title, SizeOf(Title), #0);

  if GetClassName(h, @ClassName, 255) > 0 then begin
    if StrLComp(ClassName, 'Afx:ToolBar:', 12) = 0 then begin
      if GetWindowText(h, @Title, 255) > 0 then begin
        if StrLComp(Title,  'j[ o[', 7) = 0 then begin
          menuBarHWnd := h;
          Result := False;
        end;
      end;
    end;
  end;
end;

function EnumChildWindowProcGeneLay(h: HWND; lp: LPARAM):Bool; stdcall;
var
  Title : array [0..255] of char;
begin
  Result := True;
  FillChar(Title, SizeOf(Title), #0);
  //^Cg̎擾
  if GetWindowText(h, @Title, 255) > 0 then begin
    if (AnsiPos('General.Layer', Title) > 0)then begin
      geneLayHWnd := h;
      Result := False;
    end;
  end;
end;

// DockPane ̃EBhEnh
function ncadDockPaneWindow: HWND;
var
  hMain: HWND;
begin
  result := 0;

  dockPaneHWnd := 0;

  hMain := FindWindow(nil, 'nanoCAD 5');
  if hMain <> 0 then begin
    EnumChildWindows(hMain, @EnumChildWindowProcDockPane, 0);
    result := dockPaneHWnd;
  end;
end;

// j[ o[ ̃EBhEnh
function ncadMenuBarWindow: HWND;
var
  hMain: HWND;
begin
  result := 0;

  menuBarHWnd := 0;

  hMain := FindWindow(nil, 'nanoCAD 5');
  if hMain <> 0 then begin
    EnumChildWindows(hMain, @EnumChildWindowProcMenuBar, 0);
    result := menuBarHWnd;
  end;
end;

// wR{{bNX̃EBhEnh
function ncadGeneLayWindow: HWND;
var
  hMain: HWND;
begin
  result := 0;

  geneLayHWnd := 0;

  hMain := FindWindow(nil, 'nanoCAD 5');
  if hMain <> 0 then begin
    EnumChildWindows(hMain, @EnumChildWindowProcGeneLay, 0);
    result := geneLayHWnd;
  end;
end;

// nanoCAD CEBhE
function ncadMainWindow: HWND;
begin
  result := FindWindow(nil, 'nanoCAD 5');
end;

// R}hCi[U[͂镔j̃EBhEnh
function ncadCmdEditWindow: HWND;
var
  h, hCmdHist, hCmdEdit, hMain: hwnd;
begin
  result := 0;

  hMain := FindWindow(nil, 'nanoCAD 5');
  if hMain <> 0 then begin
    h := FindWindowEx(hMain, 0, nil, 'Command Line');
    h := GetWindow(h, GW_CHILD);
    h := GetWindow(h, GW_CHILD);
    hCmdHist := GetWindow(h, GW_HWNDNEXT); // Hist
    hCmdEdit := GetWindow(hCmdHist, GW_HWNDNEXT); // Edit
    result := hCmdEdit;
  end;
end;

// R}hCi[U[͂镔j̕擾
function ncadCmdEdit: string;
var
  h, hCmdHist, hCmdEdit, hMain: HWND;
begin
  result := '';

  hMain := FindWindow(nil, 'nanoCAD 5');
  if hMain <> 0 then begin
    h := FindWindowEx(hMain, 0, nil, 'Command Line');
    h := GetWindow(h, GW_CHILD);
    h := GetWindow(h, GW_CHILD);
    hCmdHist := GetWindow(h, GW_HWNDNEXT); // Hist
    hCmdEdit := GetWindow(hCmdHist, GW_HWNDNEXT); // Edit
    result := GetWindowStr(hCmdEdit);
  end;
end;

// R}hC擪 Statc ̃EBhE
function ncadCmdStaticWindow: HWND;
var
  h, hCmdHist, hCmdEdit, hMain, hCmdStatic : HWND;
begin
  result := 0;
  hMain := FindWindow(nil, 'nanoCAD 5');
  if hMain <> 0 then begin
    h := FindWindowEx(hMain, 0, nil, 'Command Line');
    h := GetWindow(h, GW_CHILD);
    h := GetWindow(h, GW_CHILD);
    hCmdHist := GetWindow(h, GW_HWNDNEXT); // Hist
    hCmdEdit := GetWindow(hCmdHist, GW_HWNDNEXT); // Edit
    hCmdStatic := GetWindow(hCmdEdit, GW_HWNDNEXT); //Static
    result := hCmdStatic;
  end;
end;

// R}h̕擾
function ncadCmdHistWindow: HWND;
var
  h, hCmdHist, hMain: hwnd;
begin
  result := 0;

  hMain := FindWindow(nil, 'nanoCAD 5');
  if isWindow(hMain) then begin
    h := FindWindowEx(hMain, 0, nil, 'Command Line');
    h := GetWindow(h, GW_CHILD);
    h := GetWindow(h, GW_CHILD);
    hCmdHist := GetWindow(h, GW_HWNDNEXT); // Hist
    result := hCmdHist;
  end;
end;

// R}h̕擾
function ncadCmdHist: String;
var
  h, hCmdHist, hMain: hwnd;
begin
  result := '';

  hMain := FindWindow(nil, 'nanoCAD 5');
  if isWindow(hMain) then begin
    h := FindWindowEx(hMain, 0, nil, 'Command Line');
    h := GetWindow(h, GW_CHILD);
    h := GetWindow(h, GW_CHILD);
    hCmdHist := GetWindow(h, GW_HWNDNEXT); // Hist
    result := GetWindowStr(hCmdHist);
  end;
end;

// }ʐƃ^CgAEBhEnh𓾂
function ncadDocsTitle(var sl: TStringList): integer;
var
  hMain, hMDIClient, h: HWND;
  Title : array [0..255] of Char;
  s: string;
  slFlag : boolean;
begin
  result := 0;

  FillChar(Title, SizeOf(Title), #0);

  slFlag := Assigned(sl);
  if slFlag then sl.Clear;

  hMain := FindWindow(nil, 'nanoCAD 5');
  hMDIClient := FindWindowEx(hMain, 0, 'MDIClient', nil);
  if hMDIClient <> 0 then begin
    h := GetWindow(hMDIClient, GW_CHILD);
    while (h <> 0) do begin
      s := '';
      if GetWindowText(h, @Title, 255) > 0 then s := Title;
      if s = '' then break
      else begin
        Inc(result);
        if slFlag then sl.AddObject(s, TObject(h));
        h := GetWindow(h, GW_HWNDNEXT);
      end;
    end;
  end;
end;

// hLg𓾂
function ncadDocsCount: integer;
var
  hMain, hMDIClient, h: HWND;
  Title : array [0..255] of Char;
  s: string;
begin
  result := 0;

  FillChar(Title, SizeOf(Title), #0);

  hMain := FindWindow(nil, 'nanoCAD 5');
  hMDIClient := FindWindowEx(hMain, 0, 'MDIClient', nil);
  if hMDIClient <> 0 then begin
    h := GetWindow(hMDIClient, GW_CHILD);
    while (h <> 0) do begin
      s := '';
      if GetWindowText(h, @Title, 255) > 0 then s := Title;
      if s = '' then break
      else begin
        Inc(result);
        h := GetWindow(h, GW_HWNDNEXT);
      end;
    end;
  end;
end;

// ANeBuhLg̃^Cg
//
// gqȂ= VK}ʁiۑj
// * t= ύXiۑj
// tl[= obNAbvt@C
function ncadActiveDocTitle: string;
var
  hMain, hMDIClient, h: HWND;
  Title : array [0..255] of Char;
begin
  result := '';
  FillChar(Title, SizeOf(Title), #0);
  hMain := FindWindow(nil, 'nanoCAD 5');
  hMDIClient := FindWindowEx(hMain, 0, 'MDIClient', nil);
  if hMDIClient <> 0 then begin
    h := GetWindow(hMDIClient, GW_CHILD);
    if GetWindowText(h, @Title, 255) > 0 then result := Title;
  end;
end;

// OtBbNEBhẼnh
function ncadGraphicWindow: HWND;
var
  hMain, hMDIClient, h: HWND;
begin
  result := 0;
  hMain := FindWindow(nil, 'nanoCAD 5');
  hMDIClient := FindWindowEx(hMain, 0, 'MDIClient', nil);
  if hMDIClient <> 0 then begin
    h := GetWindow(hMDIClient, GW_CHILD);
    h := GetWindow(h, GW_CHILD);
    result := GetWindow(h, GW_HWNDNEXT);
  end;
end;

// nanoCAD ANeBuɂăL[
procedure ncadKeybdEvent(key: UInt);
var
  hMain, h: HWND;
begin
  hMain := ncadMainWindow;
  if hMain <> 0 then begin
    SetForegroundWindow(hMain);
    Sleep(50);
    h := GetForegroundWindow;
    if h = hMain then begin
      //SetForegroundWindow(ncadCmdEditWindow);
      keybd_event(Key, 0, 0, 0);
      keybd_event(Key, 0, KEYEVENTF_KEYUP, 0);
    end;
  end;
end;

// ANeBu
function ncadActivate: HWND;
var
  hMain: HWND;
begin
  hMain := FindWindow(nil, 'nanoCAD 5');
  if hMain <> 0 then
    SetForegroundWindow(hMain);
  result := hMain;
end;

// Enter
procedure ncadSendEnter;
begin
  ncadKeybdEvent(VK_RETURN);
end;

// ESC
procedure ncadSendCancel;
begin
  ncadKeybdEvent(VK_ESCAPE);
end;

// nanoCAD ŏĂ邩
function ncadIsMinimized: boolean;
var
  hMain:HWND;
  iStyle: integer;
begin
  hMain := FindWindow(nil, 'nanoCAD 5');
  iStyle := GetWindowLongPtr(hMain, GWL_STYLE);
  result := (iStyle and WS_MINIMIZE) <> 0;
end;

// Window ŏĂ邩
function windowIsMinimized(h: HWND): boolean;
var
  iStyle: integer;
begin
  iStyle := GetWindowLongPtr(h, GWL_STYLE);
  result := (iStyle and WS_MINIMIZE) <> 0;
end;

// nanoCAD ő剻
procedure ncadShowMaxmize;
var
  hMain:HWND;
begin
  hMain := FindWindow(nil, 'nanoCAD 5');
  ShowWindow(hMain, SW_MAXIMIZE); // ő剻
end;

// window ő剻
procedure windowShowMaxmize(h: HWND);
begin
  ShowWindow(h, SW_MAXIMIZE); // ő剻
end;

// nanoCAD ݂̈ʒuƃTCYŕ\
procedure ncadShowNormal;
var
  hMain:HWND;
begin
  hMain := FindWindow(nil, 'nanoCAD 5');
  ShowWindow(hMain, SW_SHOWNORMAL); // ݂̈ʒuƃTCYŕ\
end;

// window ݂̈ʒuƃTCYŕ\
procedure windowShowNormal(h: HWND);
begin
  ShowWindow(h, SW_SHOWNORMAL); // ݂̈ʒuƃTCYŕ\
end;

// N EXE tpXŎ擾
function exeFullName(exeHWnd: HWND): string;
// http://mrxray.on.coocan.jp/Delphi/plSamples/320_AppList.htm
const
  PROCESS_QUERY_LIMITED_INFORMATION = $1000;
var
  pid: DWORD;
  procHandle : THandle;
  buf : array [0..MAX_PATH - 1] of Char;
  STR_SIZE    : DWORD;
begin
  result := '';
  GetWindowThreadProcessId(exeHWnd, Addr(pid));
  procHandle := OpenProcess(PROCESS_QUERY_LIMITED_INFORMATION,
                              False,
                              pid);
  try
    // EXE ̃tpX擾
    FillChar(buf, SizeOf(buf), #0);
    STR_SIZE := Length(buf);
    //exeFullPath :='';
    if QueryFullProcessImageNameW(procHandle,
                                  0,
                                  @buf[0],
                                  @STR_SIZE) > 0 then begin
      result := buf;
    end;
  finally
    CloseHandle(procHandle);
  end;
end;
// X^[gAbvEBhE
function ncadStartupWindow: HWND;
begin
  result := FindWindow(nil, 'nanoCAD 5.0');
end;


end.
